// The following ifdef block is the standard way of creating macros which make exporting
// from a DLL simpler. All files within this DLL are compiled with the LABJACKWUSB_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see
// LABJACKWUSB_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef LABJACKWUSB_EXPORTS
#define LABJACKWUSB_API __declspec(dllexport)
#else
#define LABJACKWUSB_API __declspec(dllimport)
#endif

#include <windows.h>
#include <setupapi.h>
#include <WinUsb.h>
#include <Usb100.h>
#include <strsafe.h>

/*
// This class is exported from the LabJackWUSB.dll
class LABJACKWUSB_API CLabJackWUSB {
public:
	CLabJackWUSB(void);
	// TODO: add your methods here.
};

extern LABJACKWUSB_API int nLabJackWUSB;

LABJACKWUSB_API int fnLabJackWUSB(void);
*/


//LABJACKWUSB_API

LABJACKWUSB_API UINT LJWUSB_GetDevCount(GUID * USB_GUID);
/*
void USBDRVD_PipeClose(IN HANDLE hPipe);
*/
LABJACKWUSB_API BOOL LJWUSB_PipeWriteTimeout(WINUSB_INTERFACE_HANDLE usbHandle, unsigned char pipe, unsigned char* lpBuffer, unsigned long nNumberOfBytesToWrite, unsigned long * lpNumberOfBytesWritten, unsigned long dwTimeout);

LABJACKWUSB_API BOOL LJWUSB_PipeReadTimeout(WINUSB_INTERFACE_HANDLE usbHandle, unsigned char pipe, unsigned char* lpBuffer, unsigned long nNumberOfBytesToRead, unsigned long * lpNumberOfBytesRead, unsigned long dwTimeout);

LABJACKWUSB_API WINUSB_INTERFACE_HANDLE LJWUSB_OpenDevice(UINT DevNum, GUID * USB_GUID, char *devPath, HANDLE *hDev);

LABJACKWUSB_API unsigned char LJWUSB_PipeOpenPath(WINUSB_INTERFACE_HANDLE usbHandle, UINT Pipe, DWORD dwFlagsAndAttributes);

LABJACKWUSB_API BOOL LJWUSB_Free(WINUSB_INTERFACE_HANDLE usbHandle, HANDLE *hDev);

LABJACKWUSB_API BOOL LJWUSB_GetDevicePath(UINT DevNum, GUID * USB_GUID, char *devPath);

LABJACKWUSB_API BOOL LJWUSB_PipeSetTimeout(WINUSB_INTERFACE_HANDLE usbHandle, UINT Pipe, UINT Timeout);

/**
 * Desc: Attempts to clear a pipe (for example, to cause all pending reads on
 *       that pipe to finish immediately).
 * Para: usbHandle, A handle to the USB device
 *       pipe, the pipe to clear
 * Retr: 1 on success
 *       0 on failure
**/
LABJACKWUSB_API BOOL LJWUSB_FlushAndAbort(WINUSB_INTERFACE_HANDLE usbHandle, UINT Pipe);

/**
 * Desc: Attempts to reset a pipe.
 * Retr: 1 on success
 *       0 on failure
**/
LABJACKWUSB_API BOOL LJWUSB_ResetPipe(WINUSB_INTERFACE_HANDLE usbHandle, UINT Pipe);

LABJACKWUSB_API BOOL LJWUSB_PipeSetPolicy(WINUSB_INTERFACE_HANDLE usbHandle, unsigned char pipe, unsigned long type, unsigned long length, void * value);

/*
BOOL USBDRVD_ResetPipe(IN HANDLE hPipe);

USBDRVD_API BOOL USBDRVD_CyclePort(HANDLE hDevice);

UINT USBDRVD_GetDeviceDescriptor(IN HANDLE hDevice, IN OUT
USBDRV_DEVICE_DESCRIPTOR * Device);

USBDRVD_API HANDLE USBDRVD_OpenDevicePath(char *PnP_Path,
DWORD dwReserved);

void USBDRVD_CloseDevice(IN HANDLE hDevice);

BOOL USBDRVD_PipeAbort(IN HANDLE hPipe);*/


